view hgmerge @ 1187:120aa5fc7ced

From mercurial-bounces@selenic.com Thu Sep 1 07:01:32 2005 Return-Path: <mercurial-bounces@selenic.com> X-Original-To: bos@serpentine.com Delivered-To: bos@serpentine.com Received: from waste.org (waste.org [216.27.176.166]) by demesne.serpentine.com (Postfix) with ESMTP id 3616A20B571 for <bos@serpentine.com>; Thu, 1 Sep 2005 07:01:32 -0700 (PDT) Received: from waste.org (localhost [127.0.0.1]) by waste.org (8.13.4/8.13.4/Debian-3) with ESMTP id j81DxodQ028829; Thu, 1 Sep 2005 08:59:51 -0500 Received: from web32904.mail.mud.yahoo.com (web32904.mail.mud.yahoo.com [68.142.206.51]) by waste.org (8.13.4/8.13.4/Debian-3) with SMTP id j81DxnNA028824 for <mercurial@selenic.com>; Thu, 1 Sep 2005 08:59:49 -0500 Received: (qmail 25859 invoked by uid 60001); 1 Sep 2005 13:59:17 -0000 DomainKey-Signature: a=rsa-sha1; q=dns; c=nofws; s=s1024; d=yahoo.com; h=Message-ID:Received:Date:From:Subject:To:In-Reply-To:MIME-Version:Content-Type:Content-Transfer-Encoding; b=O6sELrlCknW3M/gKVqijWs82e/CbDEum1sEitcuLKXaP9dHU175PszOqMgcSKykMY+BVXtcH3NeaXLM3FyBmqNkoPAvesezyFbgQsHSM1S028oOexybCKMvtGQJmz66hzd1fDb0QoPj1gCcGU2VDevQaOesSmo1xF9jJwy2LlLE= ; Message-ID: <20050901135917.25856.qmail@web32904.mail.mud.yahoo.com> Received: from [60.48.222.94] by web32904.mail.mud.yahoo.com via HTTP; Thu, 01 Sep 2005 06:59:17 PDT Date: Thu, 1 Sep 2005 06:59:17 -0700 (PDT) From: TK Soh <teekaysoh@yahoo.com> To: mercurial@selenic.com In-Reply-To: <20050828075808.GO27787@waste.org> MIME-Version: 1.0 Content-Type: text/plain; charset=iso-8859-1 X-Virus-Scanned: by amavisd-new Subject: Re: add -p to hg tip X-BeenThere: mercurial@selenic.com X-Mailman-Version: 2.1.5 Precedence: list List-Id: mercurial.selenic.com List-Unsubscribe: <http://selenic.com/mailman/listinfo/mercurial>, <mailto:mercurial-request@selenic.com?subject=unsubscribe> List-Archive: <http://www.selenic.com/pipermail/mercurial> List-Post: <mailto:mercurial@selenic.com> List-Help: <mailto:mercurial-request@selenic.com?subject=help> List-Subscribe: <http://selenic.com/mailman/listinfo/mercurial>, <mailto:mercurial-request@selenic.com?subject=subscribe> Sender: mercurial-bounces@selenic.com Errors-To: mercurial-bounces@selenic.com X-Spam-Checker-Version: SpamAssassin 3.0.4 (2005-06-05) on demesne.serpentine.com X-Spam-Level: X-Spam-Status: No, score=-1.6 required=5.0 tests=AWL,BAYES_00 autolearn=ham version=3.0.4 X-Evolution-Source: imap://bos@www.serpentine.com/ Content-Transfer-Encoding: 8bit
author bos@serpentine.internal.keyresearch.com
date Thu, 01 Sep 2005 07:47:26 -0700
parents 9c918287d10b
children 696851b1bba9
line wrap: on
line source

#!/bin/sh
#
# hgmerge - default merge helper for Mercurial
#
# This tries to find a way to do three-way merge on the current system.
# The result ought to end up in $1.

set -e # bail out quickly on failure

LOCAL="$1"
BASE="$2"
OTHER="$3"

if [ -z "$EDITOR" ]; then
    EDITOR="vi"
fi

# Back up our file
cp "$LOCAL" "$LOCAL.orig"

# Attempt to do a non-interactive merge
if type merge > /dev/null 2>&1; then
    merge "$LOCAL" "$BASE" "$OTHER" 2> /dev/null && exit 0
    cp "$LOCAL.orig" "$LOCAL"
elif type diff3 > /dev/null 2>&1; then
    diff3 -m "$LOCAL.orig" "$BASE" "$OTHER" > "$LOCAL" && exit 0
    cp "$LOCAL.orig" "$LOCAL"
fi

if [ -n "$DISPLAY" ]; then
    # try using kdiff3, which is fairly nice
    if type kdiff3 > /dev/null 2>&1; then
	kdiff3 --auto "$BASE" "$LOCAL" "$OTHER" -o "$LOCAL" || exit 1
	exit 0
    fi

    # try using tkdiff, which is a bit less sophisticated
    if type tkdiff > /dev/null 2>&1; then
	tkdiff "$LOCAL" "$OTHER" -a "$BASE" -o "$LOCAL" || exit 1
	exit 0
    fi
fi

# Attempt to do a merge with $EDITOR
if type merge > /dev/null 2>&1; then
    echo "conflicts detected in $LOCAL"
    merge "$LOCAL" "$BASE" "$OTHER" 2>/dev/null || $EDITOR "$LOCAL"
    exit 0
fi

if type diff3 > /dev/null 2>&1; then
    echo "conflicts detected in $LOCAL"
    diff3 -m "$LOCAL.orig" "$BASE" "$OTHER" > "$LOCAL" || $EDITOR "$LOCAL"
    exit 0
fi

HGTMP=""
cleanup_exit() {
    rm -rf "$HGTMP"
}

# attempt to manually merge with diff and patch
if type diff > /dev/null 2>&1 && type patch > /dev/null 2>&1; then
    # Remove temporary files even if we get interrupted
    trap "cleanup_exit" 0 # normal exit
    trap "exit 1" 1 2 3 6 15 # HUP INT QUIT ABRT TERM

    HGTMP="${TMPDIR-/tmp}/hgmerge.$RANDOM.$RANDOM.$RANDOM.$$"
    (umask 077 && mkdir "$HGTMP") || {
	echo "Could not create temporary directory! Exiting." 1>&2
	exit 1
    }

    diff -u "$BASE" "$OTHER" > "$HGTMP/diff"
    if patch "$LOCAL" < "$HGTMP/diff"; then
	exit 0
    else
	# If rejects are empty after using the editor, merge was ok
	$EDITOR "$LOCAL" "$LOCAL.rej" && test -s "$LOCAL.rej" || exit 0
    fi
    exit 1
fi

echo "hgmerge: unable to find merge, tkdiff, kdiff3, or diff+patch!"
exit 1